;+
; COMPARERK
;
; Intent:
;        Determine whether runge-kutta steps are too different, and adjust h
;        if so
;
; History:
;        CB, October 2006
;-

function compareRK, dx1, dx2, h

d = dx1 - dx2
ratio = sqrt(total(d^2)/h^2)

if ratio gt 0.1 then begin
    
    h = (h * 0.8) > 0.01
    return, 0
endif

if ratio lt 0.001 then begin
    h = (1.2 * h) < 1.
endif

return, 1

end
