;+
; CUBEOBJECT::FINDNULLS
;
; Intent:
;        Given QCPs on the border of a box, integrate curves of
;        Bx=By=0 across it until we leave the box
;
; History:
;        CB, October 2006
;-

pro cubeObject::FindNulls

q = self->getQCPs(nq=nq)
nulls = [0,0,0.]
for i =0,nq-1 do begin
    curve1 = self->integrateZeroCurve (q[i], dir = +1)
    curve2 = self->integrateZeroCurve (q[i], dir = -1)
    n1 = self->curve2nulls(curve1, pts = pts1)
    n2 = self->curve2nulls(curve2, pts = pts2)
    for j = 0, n1-1 do begin
        self->addNull, pts1[*,j]
    endfor
    for j = 0, n2 - 1 do begin
        self->addNull, pts2[*,j]
    endfor

endfor 
;stop
end
