;+
;  CUBEOBJECT::GETPLANES
; 
; Intent:
;         Return the plane on which to take the contours
;
; History:
;         CB, October 2006
;-

pro cubeObject::GetPlanes, top=top, bottom=bottom, left=left, $
                   right = right, front = front, back = back, $
                   xplane = xplane, yplane = yplane

cube = self -> getCube()
size = self -> getsize()
xmax = size[0]-1
ymax = size[1]-1
zmax = size[2]-1

case 1 of
    keyword_set(top): begin
        xplane = cube[0,*,*,zmax]
        yplane = cube[1,*,*,zmax]
    end 
    keyword_set(bottom): begin
        xplane = cube[0,*,*,0]
        yplane = cube[1,*,*,0]
    end 
    keyword_set(left): begin
        xplane = cube[0,0,*,*]
        yplane = cube[1,0,*,*]
    end 
    keyword_set(right): begin
        xplane = cube[0,xmax,*,*]
        yplane = cube[1,xmax,*,*]
    end 
    keyword_set(front): begin
        xplane = cube[0,*,0,*]
        yplane = cube[1,*,0,*]
    end 
    keyword_set(back): begin
        xplane = cube[0,*,ymax,*]
        yplane = cube[1,*,ymax,*]
    end 
endcase
xplane = reform(xplane)
yplane = reform(yplane)
end
