;+
; CUBEOBJECT::RKZSTEP
;
; Intent:
;        Do a runge-kutta step of the appropriate size
;
; History:
;        CB, October 2006
;-

function cubeObject::rkfunc, x

db = self->calcderivs(x)
return, normalise(crossp(db[*,0], db[*,1]))
end

function cubeObject::rkzstep, x, h, dir

k1 = h * dir * self->rkfunc(x)
k2 = h * dir * self->rkfunc(x + 0.5 * k1)
k3 = h * dir * self->rkfunc(x + 0.5 * k2)
k4 = h * dir * self->rkfunc(x + k3)

return, 1./6. * (k1 + 2*k2 + 2*k3 + k4)
end

