;+
; CUBEOBJECT::CURVE2NULLS
;
; Intent:
;        Take a curve and determine where Bz changes on it
;
; History:
;        CB, October 2006
;-

function cubeObject::myNewton, x

Bmax = max(abs(self->getCube()))
count = 0
repeat begin
    B = self->calcField(x)
    J = self->calcDerivs(x)
    Ji = invert(J)
    dx = - Ji ## B
    x = x + dx
    count = count + 1
endrep until B lt Bmax * 1.e-10 or count gt 1000

if count gt 1000 then return, 0 
return, x

end

;function newtonfunc, x
;
;return, interpolate(cube, x[0], x[1],x[2])
;end

function cubeObject::curve2nulls, curve, pts = pts


nc = n_elements(curve[0,*])
w = where(curve[5,0:nc-2] * curve[5,1:nc-1] lt 0, n)

if n eq 0 then return, 0

z1 = rebin(reform(curve[5,w]), 6, n)
z2 = rebin(reform(curve[5,w+1]), 6, n)
pt = (-z1 * curve[*, w] + z2 * curve[*, w+1]) / (z2-z1)
p1 = [0.,0.,0.]
out = 0
for i =0, n - 1 do begin
    pti = broyden(pt[0:2,i], 'newtonfunc')
    if n_elements(pti) eq 3 then begin
        p1 = [[p1],[pti]]
        out = out + 1
    endif
endfor
if out eq 0 then return, 0
pts = p1[*,1:*]
return, out
end
