;+
; NOOFCROSSINGS
;
; Intent:
;        Given two curves, determine how many times they cross, and where.
;
; History:
;        CB, October 2006
;-

function noOfCrossings, c1, c2, cross = cross

n1 = n_elements(c1[0,*])
n2 = n_elements(c2[0,*])

b12 = bytarr(n1-1) + 1
b34 = bytarr(n2-1) + 1


x1 = b34 # c1[0,0:n1-2]  &  x2 = b34 # c1[0,1:n1-1] 
x3 = b12 # c2[0,0:n2-2]  &  x4 = b12 # c2[0,1:n2-1] 
y1 = b34 # c1[1,0:n1-2]  &  y2 = b34 # c1[1,1:n1-1] 
y3 = b12 # c2[1,0:n2-2]  &  y4 = b12 # c2[1,1:n2-1] 

x3 = transpose(x3) & x4 = transpose(x4)
y3 = transpose(y3) & y4 = transpose(y4)
;stop

a = x1 - x3 & b = y1 - y3
c = x1 - x2 & e = y1 - y2
d = x4 - x3 & f = y4 - y3
det = (c * f - d * e)
w = where(det eq 0, nw)
if nw ne 0 then det[w] = 1.e-30


lam = (f * a - d * b) / det
mu  = (c * b - e * a) / det

w = where(lam gt 0 and lam lt 1 and mu gt 0 and mu lt 1, count)
if count eq 0 then return, 0

cross1x = x1[w] + lam[w] * (x2[w] - x1[w])
cross1y = y1[w] + lam[w] * (y2[w] - y1[w])
;cross2x = x3[w] + mu[w] * (x4[w] - x3[w])
;cross2y = y3[w] + mu[w] * (y4[w] - y3[w])
;stop
cross = fltarr(2,count)
cross[0,*] = cross1x
cross[1,*] = cross1y
return, count
end
