;+
; ONULLFINDER
;
; [Cube O-Null-Finder]
;
; Intent:
;        Given a computational box, determine the imbalance between the
;        numbers of +ve and -ve nulls inside; also find them if required.
;
; History:
;        CB, October 2006
;-

function onullfinder, cube, predict = predict, nulls = nulls, xr = xr, yr=yr, zr=zr

;stop
cb = createCubeObject(cube, xr=xr, yr=yr, zr=zr)

cb -> LocateQCPs

cb -> CheckModifiedEuler, /threed, imb = imb

if keyword_set(predict) then return, imb

cb -> FindNulls

nulls = cb->getNulls(nn = nn)
nulls = nulls + rebin([xr[0], yr[0], zr[0]], 3, nn)
return, nn 

end
