;+
; QCP::CALCSURF
;
; Note:
;      self.surf = 1 on the bottom surface, 2 on the ceiling.
;-

pro qcp::calcSurf, acc

if self.pos[2] eq acc[2]-1 then begin
    self.surf = 2
    return
endif
if self.pos[2] eq 0 then begin
    self.surf = 1
    return
end
d = self.derivs

cross = crossp(d[0,*], d[1,*])

case 1 of 
    self.pos[0] eq 0.: if cross[0] lt 0 then cross = -cross
    self.pos[1] eq 0.: if cross[1] lt 0 then cross = -cross
    self.pos[0] eq acc[0]-1: if cross[0] gt 0 then cross = -cross
    self.pos[1] eq acc[1]-1: if cross[1] gt 0 then cross = -cross
    else: stop
endcase

; cross is now pointing into the cube. 
if cross[2] lt 0 then self.surf = 2 else self.surf = 1

end
